use strict;
use warnings;
use AnyEvent::HTTP;
use Fcntl qw/:flock/;


my @cat_list = qw/ARCADE BRAIN CARDS CASUAL GAME_WALLPAPER RACING SPORTS_GAMES GAME_WIDGETS/;
my $page_limit = 15;
my $res_file = 'result1.txt';

$| = 1;
my $time = time;

for my $cat_name(@cat_list)
{
    my $cv = AnyEvent->condvar;
    
    for(my ($i, $j) = (0, 0); $i < $page_limit; $i++)
    {
        print $cat_name, ' - ', $i, $/;
        
        http_get
        (
            'https://market.android.com/details?id=apps_topselling_paid&cat='.$cat_name.'&start='.($i * 25).'&num=25',
            headers => 
            {
                'User-Agent' => 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.2)'
            },
            timeout => 5,
            sub 
            {
                my ($data, $headers) = @_;
            
                if($headers->{Status} =~ /^200/)
                {
                    open F, '>>', $res_file or warn $!;
                    flock F, LOCK_EX;
                    
                    print F (join $/, $data =~ /data-docid="(.+?)"/g), $/;
                    
                    flock F, LOCK_UN;
                    close F;
                }
                
                if(++$j == $page_limit)
                {
                    $cv->send;
                }
            }
        );
    }
    
    $cv->recv;
}
print 'Time elapsed: ', time - $time, $/;
